﻿using System;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript;
using System.Collections;
using columnchoosertoolbar.Grid;
namespace columnchoosertoolbar
{
    public partial class ToolbarController: Controller
    {
        public ActionResult ToolbarFeatures()
        {
            return View();
         }
        public ActionResult Data(DataManager dm)
        {
            IEnumerable DataSource = new NorthwindDataContext().EmployeeViews;

            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformWhereFilter(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.AsQueryable().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            var jsonResult = Json(new { result = DataSource, count = count }, JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = int.MaxValue;
            return jsonResult;
        }

        public ActionResult ChildDatas(DataManager dm)
        {
            IEnumerable ChDataSource = new NorthwindDataContext().OrdersViews;

            Syncfusion.JavaScript.DataSources.DataOperations operation = new Syncfusion.JavaScript.DataSources.DataOperations();
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                ChDataSource = operation.PerformSorting(ChDataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                ChDataSource = operation.PerformWhereFilter(ChDataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = ChDataSource.AsQueryable().Count();
            if (dm.Skip != 0)
            {
                ChDataSource = operation.PerformSkip(ChDataSource, dm.Skip);
            }
            if (dm.Take != 0)
            {
                ChDataSource = operation.PerformTake(ChDataSource, dm.Take);
            }
            var jsonResult = Json(new { result = ChDataSource, count = count }, JsonRequestBehavior.AllowGet);
            jsonResult.MaxJsonLength = int.MaxValue;
            return jsonResult;
        }

        public static List<OrdersData> GetData()
        {


            Random r = new Random();
            string[] words = { "India", "USA", "France", "Brazil", "Denmark", "Asia", "Africa", "China", "Canada", "Argentina", "England", "Japan", "Afganistan", "Malysia", "Singapore", "WestIndies", "SouthAfrica", "Austrilia", "Dubai", "Turkey", "Pakistan", "Bangaladesh", "Srilanka", "Saudhi", "kenya", "Jamica", "Russia", "Uruguve", "South Koriya", "GBk", "Nz", "Zim", "Hol", "Nab", "por", "Nel" };
            List<OrdersData> obj = new List<OrdersData>();
            for (var i = 1; i < 10001; i++)
            {

                string word = words[r.Next(0, words.Length)];
                obj.Add(new OrdersData() { OrderID = 100 + i, EmployeeID = i, ShipCity = word });
            }
            return obj;
        }
    }
    public class OrdersData
    {
        public int OrderID { get; set; }
        public int EmployeeID { get; set; }
        public string ShipCity { get; set; }
    }
}
